000010*@M	       MAIN
000020 IDENTIFICATION DIVISION.
000030 PROGRAM-ID. PHAY.
000040 DATE-COMPILED.
000050* ------------------------: GS Print Hither and Yon test
000060*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000070 ENVIRONMENT DIVISION.
000080*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000090 CONFIGURATION SECTION.
000100 SOURCE-COMPUTER. IBM-PC.
000110 OBJECT-COMPUTER. IBM-PC.
000120*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000130 DATA DIVISION.
000140*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000150 WORKING-STORAGE SECTION.
       01  V--VERSION-LEVEL PIC 9(3) VALUE 11.				060110ja
000170*
000180* ------------------------: Copy a main panel
000190	       COPY PHAYMAIN.
000200*
000210* ------------------------: Copy the panel for the PHAYPANL ETC
000220	       COPY PHAYPANL.
000230	       COPY PHAYTIME.
000240* 			: copybooks for APIs
000250	       COPY WIN32API.
000260	       COPY WINEXEC.
000270	       COPY PRTFILE.
000280	       COPY GETPRINT.
000290	       COPY GSPRTDEF.
000300*
000310 01  WS-SIZE-DM			    PIC 9999.
000320 01  WS-SIZE-ONE			    PIC 9999.
000330 01  WS-SIZE-TWO			    PIC 9999.
000340*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000350 PROCEDURE DIVISION.
000360*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000370*
000380	   PERFORM 0110-INITIALIZE-GS.
000390*
000400* ------------------------: Display the test panel.
000410*
000420	   PERFORM WITH TEST AFTER
000430		 UNTIL PHAYPANL-EVENT-CLOSE-AND-STOP
000440		 OR PHAYPANL-CANCEL
000450*
000460	     CALL 'GS' USING PHAYPANL-1
000470			     PHAYPANL-2
000480			     PHAYPANL-3
000490			     PHAYPANL-4
000500*
000510	     MOVE LOW-VALUES TO PRTFILE-PARMS
000520	     EVALUATE TRUE
000530* 			:
000540	       WHEN PHAYPANL-CLI-TO-CLI
000550		 PERFORM 0101-GEN-LOCAL-TEXT
000560		 PERFORM 0103-PRINT-LOCAL-TO-LOCAL
000570*
000580	       WHEN PHAYPANL-CLI-TO-SER
000590		 PERFORM 0101-GEN-LOCAL-TEXT
000600		 PERFORM 0105-PRINT-CLIENT-TO-SERVER
000610*
000620	       WHEN PHAYPANL-SER-TO-CLI
000630		 PERFORM 0102-GEN-SERVER-TEXT
000640		 PERFORM 0104-PRINT-SERVER-TO-LOCAL
000650*
000660	       WHEN PHAYPANL-SER-TO-SER
000670		 PERFORM 0102-GEN-SERVER-TEXT
000680		 PERFORM 0106-PRINT-SERVER-TO-SERVER
000690*
000700	     END-EVALUATE
000710	   END-PERFORM.
000720*
000730* ------------------------: Close the main before doing a STOP RUN
000740*
000750	   SET PHAYMAIN-DO-CLOSE TO TRUE.
000760	   CALL 'GS' USING PHAYMAIN-1
000770			   PHAYMAIN-2
000780			   PHAYMAIN-3
000790			   PHAYMAIN-4.
000800	   STOP RUN.
000810*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
000820 0100-GS-UTILITY SECTION.
000830* -====-
000840* 			: Here we run a batch job on the server
000850* 			: or local machine.
000860 0101-GEN-LOCAL-TEXT.
000870* 			: Run client side
000880	   MOVE ZERO TO WIN32API-RC
000890	   PERFORM 0108-STANDARD-GEN-TEXT.
000900* -====-
000910 0102-GEN-SERVER-TEXT.
000920* 			: Run server side
000930	   SET WIN32API-EXECUTE-API-ON-SERVER TO TRUE
000940	   PERFORM 0108-STANDARD-GEN-TEXT.
000950*
000960* 			:---------------------------------------
000970* ------------------------: These are the printing routines.
000980* 			: They all call PrintFile api.
000990* 			:---------------------------------------
001000 0103-PRINT-LOCAL-TO-LOCAL.
001010* 			: For local, we just let the user pick
001020* 			: the printer, by not feeding it a
001030* 			: printer name and just loading the hwnd
001040* 			: we also set the default printer flag
001050* 			: so it will select that printer if it
001060* 			: exists.
001070	   MOVE LOW-VALUES TO GS-DEVMODE-DATA
001080	   MOVE PHAYMAIN-HWNDMAIN TO PRTFILE-DIALOG-HWND
001090	   SET PRTFILE-SOURCE-ON-CLIENT TO TRUE
001100	   PERFORM 0109-STANDARD-PRINTFILE.
001110*
001120 0104-PRINT-SERVER-TO-LOCAL.
001130* 			: For local, we just let the user pick
001140* 			: the printer, by not feeding it a
001150* 			: printer name and just loading the hwnd
001160* 			: we also set the default printer flag
001170* 			: so it will select that printer if it
001180* 			: exists.
001190	   MOVE LOW-VALUES TO GS-DEVMODE-DATA
001200	   MOVE PHAYMAIN-HWNDMAIN TO PRTFILE-DIALOG-HWND
001210	   SET PRTFILE-SOURCE-ON-SERVER TO TRUE
001220	   PERFORM 0109-STANDARD-PRINTFILE.
001230*
001240 0105-PRINT-CLIENT-TO-SERVER.
001250* 			: For Print on the Server we hust tell
001260* 			: the api the printers name. So we first
001270* 			: get the list of printers on the server
001280* 			: and pick the default.
001290	   MOVE LOW-VALUES TO GS-DEVMODE-DATA
001300	   PERFORM 0107-FETCH-SERVERS-DEFAULT
001310	   SET PRTFILE-SOURCE-ON-CLIENT TO TRUE
001320* 			: make PrintFile run on server
001330	   SET WIN32API-EXECUTE-API-ON-SERVER TO TRUE
001340	   PERFORM 0109-STANDARD-PRINTFILE.
001350*
001360 0106-PRINT-SERVER-TO-SERVER.
001370* 			: For Print on the Server we just tell
001380* 			: the api the printers name. So we first
001390* 			: get the list of printers on the server
001400* 			: and pick the default.
001410	   MOVE LOW-VALUES TO GS-DEVMODE-DATA
001420	   PERFORM 0107-FETCH-SERVERS-DEFAULT
001430	   SET PRTFILE-SOURCE-ON-SERVER TO TRUE
001440* 			: make PrintFile run on server
001450	   SET WIN32API-EXECUTE-API-ON-SERVER TO TRUE
001460	   PERFORM 0109-STANDARD-PRINTFILE.
001470*
001480 0107-FETCH-SERVERS-DEFAULT.
001490	   SET GP-GET-ALL-MY-PRINTERS TO TRUE
001500	   SET GP-PRINT-MAX TO TRUE
001510	   SET GP-INFO-NT2KXP TO TRUE
001520	   MOVE LOW-VALUES TO GP-PRINTER-TABLE-AREA
001530*
001540* ------------------------: Call the GUI ScreenIO API routine
001550* 			: to fetch a printer list from server
001560*
001570	   SET WIN32API-EXECUTE-API-ON-SERVER TO TRUE
001580	   SET API-GETPRINTERS TO TRUE
001590	   CALL 'GSWINAPI' USING WIN32API-PARMS
001600				 GP-SERVER-HOST-NAME
001610				 GP-INFO-LEVEL
001620				 GP-PRINT-COUNT
001630				 GP-PRINTER-TABLE-AREA
001640				 WIN32API-E
001650				 WIN32API-F.
001660	   PERFORM
001670		 VARYING GPPRTDEX FROM 1 BY 1
001680		 UNTIL GPPRTDEX > 25 OR GP-ATT-DEFAULT (GPPRTDEX) = 1
001690	     CONTINUE
001700	   END-PERFORM
001710* 			: Arbitrarily move in the first
001720	   MOVE GP-PRINTER-NAME (1) TO PRTFILE-PRINTER-NAME
001730* 			: Then look for the default
001740	   IF GPPRTDEX NOT > 25 AND
001750		 GP-ATT-DEFAULT (GPPRTDEX) > 0
001760	     MOVE GP-PRINTER-NAME (GPPRTDEX) TO PRTFILE-PRINTER-NAME
001770	   END-IF.
001780*
001790 0108-STANDARD-GEN-TEXT.
001800	   SET SW-SHOWMINIMIZED TO TRUE
001810***  SET SW-SHOWNORMAL TO TRUE
001820	   STRING
001830	       'COMMAND.COM /C IPCONFIG /ALL >C:\IPCONFIG.TXT'
001840	       LOW-VALUE DELIMITED SIZE INTO WINEXEC-COMMAND-LINE
001850	   SET API-WINEXEC TO TRUE.
001860	   CALL 'GSWINAPI' USING WIN32API-PARMS
001870				 WINEXEC-COMMAND-LINE
001880				 WINEXEC-CMDSHOW
001890				 WIN32API-C
001900				 WIN32API-D
001910				 WIN32API-E
001920				 WIN32API-F.
001930* 			: Because we have to wait for that to
001940* 			: finish, we pop up a timer waster...
001950	   CALL 'GS' USING PHAYTIME-1
001960			   PHAYTIME-2
001970			   PHAYTIME-3
001980			   PHAYTIME-4.
001990*
002000 0109-STANDARD-PRINTFILE.
002010* 			: Send the selected print file to the
002020* 			: selected printer.  All the parameters
002030* 			: are set elsewhere except these few
002040	   MOVE 'Ip Info Report' TO PRTFILE-DOCUMENT-NAME
002050	   MOVE 'C:\IPCONFIG.TXT' TO PRTFILE-SOURCE-FILE-NAME
002060	   SET PRTFILE-DATA-RAW TO TRUE
002070	   SET PRTFILE-CHECK-FINAL-EJECT TO TRUE
002080	   SET FUNC-PRINTFILE TO TRUE
002090	   CALL 'GSWINAPI' USING WIN32API-PARMS
002100				 PRTFILE-PARMS
002110				 GS-DEVMODE-DATA
002120				 WIN32API-C
002130				 WIN32API-D
002140				 WIN32API-E
002150				 WIN32API-F.
002160	   MOVE DMSIZE TO WS-SIZE-DM
002170	   MOVE DMDRIVEREXTRA TO WS-SIZE-ONE
002190*
002200	   MOVE SPACE TO PHAYPANL-MESSAGE-TEXT
002210	   STRING PRTFILE-PRINTER-NAME DELIMITED LOW-VALUE
002220	       ' + ' DELIMITED SIZE
002230	       WS-SIZE-ONE '/'  WS-SIZE-DM                              060110ja
002240	       ' + ' DELIMITED SIZE
002250	       WIN32API-ERROR-TEXT DELIMITED LOW-VALUE
002260		INTO PHAYPANL-MESSAGE-TEXT
002270	   SET PHAYPANL-MESSAGE-BAR-SILENT TO TRUE
002280	   IF WIN32API-FAILED
002290	     SET PHAYPANL-MESSAGE-BAR-BEEP TO TRUE.
002300*
002310 0110-INITIALIZE-GS.
002320* 			:---------------------------------------
002330* ------------------------: Open the application window (the
002340* 			: container for this application)
002350* 			:---------------------------------------
002360*
002370	   CALL 'GS' USING PHAYMAIN-1
002380			   PHAYMAIN-2
002390			   PHAYMAIN-3
002400			   PHAYMAIN-4.
